/******************************************************************************************************************************************************
 * Name         :   TerritorySummaryComponentCtlr.cls
 * Description  :   Controller for TerritorySummaryComponent. 
 * Author       :   Raghvendra Rathore
 * Created On   :   05/02/2019
******************************************************************************************************************************************************/
public with sharing class TerritorySummaryComponentCtlr{

    /*
    * Method to fetch territory summary data based on the configuration in CIM config (different conditions for level 1 and level > 1)
    * Param 1: Selected team instance sf id
    * Param 2: Selected position sf id
    * Param 3: Selected position hierarchy level
    * Param 4: Selected Movement type
    * Param 5: Map of KPI and its national average to calculate devaition
    * Param 6: Exlude unassigned boolen to include exclude unassigned territories from result
    * Return : list PositionSummaryWrapper class.
    */
    public static list<PositionSummaryWrapper> getTerritorySummaryData(string teamInstanceId, string positionId, string positionLevel, string movementType, Map<String,String> nationalAverage, Boolean excludeUnassigned)
    {

        List<PositionSummaryWrapper> territorySummaryData = new List<PositionSummaryWrapper>();
        List<String> rootPositionIds = SalesIQUtility.getRootPositionIds(positionId);
        Map<Id,Position__c> positions = new Map<Id,Position__c>();


        //GET SUMMARY DATA IF TERRITORY IS SELECTED
        if(positionLevel == '1')
        {
            List<CIM_Position_Metric_Summary__c> listCIMMetricSummary = AlignmentUtility.getCIMMetricSummarybyPositionId(movementType, rootPositionIds, teamInstanceId, '1');
            Map<Id,List<CIM_Position_Metric_Summary__c>> mapPositionIDtoCIMMetricData = new Map<Id,List<CIM_Position_Metric_Summary__c>>();
            Map<Id,CIM_Config__c> cimConfigMap = new Map<Id,CIM_Config__c>(AlignmentUtility.getCIMConfigFieldsForTerritorySummary(movementType,teamInstanceId,'1'));

            for(CIM_Position_Metric_Summary__c cimMetricData : listCIMMetricSummary)
            {
                //SKIP UNASSIGNED TERR RECORDS TO ADD WHEN EXCLUDE FLAG IS TRUE
                if(excludeUnassigned && cimMetricData.Position_Team_Instance__r.Position_ID__r.Is_Unassigned_Position__c)  continue;
              
                positions.put
                ( cimMetricData.Position_Team_Instance__r.Position_ID__c, 
                    new Position__c
                    ( 
                        Id = cimMetricData.Position_Team_Instance__r.Position_ID__c,
                        Name = cimMetricData.Position_Team_Instance__r.Position_ID__r.Name,
                        Client_Territory_Code__c = cimMetricData.Position_Team_Instance__r.Position_ID__r.Client_Territory_Code__c,
                        Position_Type__c = cimMetricData.Position_Team_Instance__r.Position_ID__r.Position_Type__c,
                        Client_Position_Code__c = cimMetricData.Position_Team_Instance__r.Position_ID__r.Client_Position_Code__c
                    )
                );

                //ADD ALL METRICS CORRESPONSING TO A POSITION 
                //MAP POSITION ID -> LIST OF ALL CIM METRICS
                if(mapPositionIDtoCIMMetricData.containsKey(cimMetricData.Position_Team_Instance__r.Position_ID__c))
                {
                    mapPositionIDtoCIMMetricData.get(cimMetricData.Position_Team_Instance__r.Position_ID__c).add(cimMetricData);
                }
                else
                {
                    mapPositionIDtoCIMMetricData.put(cimMetricData.Position_Team_Instance__r.Position_ID__c,new list<CIM_Position_Metric_Summary__c>{cimMetricData});
                }
            }
            
            

            for(Id posId : mapPositionIDtoCIMMetricData.keyset())
            {
                string posode = positions.get(posId).Client_Position_Code__c;
                if(positions.get(posId).Client_Territory_Code__c != null)
                {
                    posode = positions.get(posId).Client_Territory_Code__c;
                }

                PositionSummaryWrapper posSummWrap = new PositionSummaryWrapper(positions.get(posId).Id, positions.get(posId).Name, posode, positions.get(posId).Position_Type__c);

                list<SummaryWrapper> allKpis = new list<SummaryWrapper>();
                system.debug('#### Position : '+positions.get(posId).Name);

                for(CIM_Position_Metric_Summary__c cimMetricData : mapPositionIDtoCIMMetricData.get(posId))
                {
                    system.debug('#### KPI : '+cimMetricData.CIM_Config__r.Display_Name__c);
                    String offset_label = AlignmentUtility.getLabelString(cimMetricData.CIM_Config__r.Display_Name__c);

                    Decimal originalValue = SalesIQUtility.getDecimalValues(cimMetricData.Original__c);
                    Decimal impactValue = SalesIQUtility.getDecimalValues(cimMetricData.Proposed__c);


                    String textColor = AlignmentUtility.GraudrailColor(originalValue,impactValue,cimConfigMap.get(cimMetricData.CIM_Config__c));
                    String graudrailHeader = AlignmentUtility.GraudrailHeader(textColor);
                    String graudrailToolTipMessage = AlignmentUtility.generateGrauidrailTooltipMessage(textColor,'',originalValue, impactValue, cimConfigMap.get(cimMetricData.CIM_Config__c));
                    String errorType = AlignmentUtility.GraudrailType(textColor);

                    Decimal changeImpact = AlignmentUtility.calculateNetLoss(originalValue,impactValue,cimConfigMap.get(cimMetricData.CIM_Config__c)).setScale(1);  
                    Decimal original_avg_dev = 0;
                    
                    if(Decimal.valueOf(nationalAverage.get(offset_label+'('+Label.Original_Metric_Value+')')) == 0)
                    {
                        original_avg_dev = 100;
                    }  
                    else
                    {
                       
                        Decimal metricNationalAverage =  Decimal.valueOf(nationalAverage.get(offset_label+'('+Label.Original_Metric_Value+')'));

                        original_avg_dev = SalesIQUtility.getPercentageDeviation(originalValue,metricNationalAverage);
                    }

                    Decimal impact_avg_dev = 0;
                    if(Decimal.valueOf(nationalAverage.get(offset_label+'('+Label.Current+')')) == 0)
                    {
                        impact_avg_dev = 100;
                    }  
                    else
                    {
                        impact_avg_dev = (((impactValue - Decimal.valueOf(nationalAverage.get(offset_label+'('+Label.Current+')'))) * 100)/Decimal.valueOf(nationalAverage.get(offset_label+'('+Label.Current+')'))).setScale(1);
                    }

                    CIM_Config__c configObj = cimConfigMap.get(cimMetricData.CIM_Config__c);
                    String thrMin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MIN;
                    String thrMax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MAX;
                    String thrWmin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MIN;
                    String thrWmax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MAX;

                    if(configObj.Metric_National_Average_Threshold_Min__c != null)
                    {
                        thrMin = String.valueOf(configObj.Metric_National_Average_Threshold_Min__c);
                        thrMax = String.valueOf(configObj.Metric_National_Average_Threshold_Max__c);
                        thrWmin = String.valueOf(configObj.Metric_National_Average_Warning_Min__c);
                        thrWmax = String.valueOf(configObj.Metric_National_Average_Warning_Max__c);

                    }
                    
                  

                    allKpis.add(new SummaryWrapper(offset_label+'('+Label.Original_Metric_Value+')', 
                        integer.valueOf(originalValue), 
                        original_avg_dev, 
                        thrMin,
                        thrMax,
                        thrWmin,
                        thrWmax));

                    allKpis.add(new SummaryWrapper(
                        offset_label+'('+Label.Current+')',
                         integer.valueOf(impactValue), 
                         '', 
                         graudrailHeader, 
                         graudrailToolTipMessage, 
                         errorType,
                         impact_avg_dev,
                         changeImpact,
                         thrMin,
                         thrMax,
                         thrWmin,
                         thrWmax
                    ));
                }
                posSummWrap.kpiData = allKpis;

                territorySummaryData.add(posSummWrap);
            }
        }

        else
        {
            list<CIM_Config__c> CIMFields = AlignmentUtility.getCIMConfigFieldsForTerritorySummary(movementType,teamInstanceId,positionLevel);
            
            set<string> configID = new set<string>();
            set<CIM_Config__c> configForCount = new set<CIM_Config__c>();
            set<CIM_Config__c> configForAggr = new set<CIM_Config__c>();

            /* HANDLE ROOT POSITIONS (LEVEL 5 and above)*/
            Set<Id> rootPosSet = new Set<Id>();
            List<Position__c> selectedPosIds = SalesIqUtility.getpositionbyid(new Set<Id>{rootPositionIds[0]});

            if(selectedPosIds[0].Hierarchy_Level__c > positionLevel)
            {
                String pos_query = 'SELECT id,name,Position_Type__c,Hierarchy_Level__c,Client_Position_Code__c,Client_Territory_Code__c,Parent_Position__c from Position__c WHERE ';
                for(Integer i = Integer.valueOf(positionLevel);i<integer.valueOf(selectedPosIds[0].Hierarchy_Level__c);i++)
                {
                    pos_query += 'Parent_Position__r.';
                }

               
                pos_query += 'Id in : rootPositionIds';
                
                if(excludeUnassigned)
                {
                    pos_query += ' AND Is_Unassigned_Position__c = '+false+'';
                }

                List<Position__c> childPosList = Database.query(pos_query);
                System.debug('CHILD POS--->' + childPosList);
                positions = new Map<Id,Position__c>(childPosList);
            }
            else
            {
                positions.put(selectedPosIds[0].Id,selectedPosIds[0]);
            }

            System.debug('POSITION_MAP--->>'+positions);
            // System.debug(positions)
            for(Id posId : positions.keyset())
            {
                string summaryCardSoqlCnt = 'SELECT ';
                string summaryCardSoqlAgr = 'SELECT CIM_Config__c cimConfig,';
                string posode = positions.get(posId).Client_Position_Code__c;
                if(positions.get(posId).Client_Territory_Code__c != null)
                {
                    posode = positions.get(posId).Client_Territory_Code__c;
                }
                
                PositionSummaryWrapper posSummWrap = new PositionSummaryWrapper(positions.get(posId).Id, positions.get(posId).Name, posode, positions.get(posId).Position_Type__c);

                for(CIM_Config__C config : CIMFields)
                {
                    system.debug('####'+config.Id);
                    if(config.Aggregation_Type__c == 'Count')
                    {
                        summaryCardSoqlCnt += config.Aggregation_Type__c + '(Id)'+config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c+' ';
                        configForCount.add(config);
                    }
                    else
                    {
                        summaryCardSoqlAgr += config.Aggregation_Type__c + '(' +config.Roll_Up_Summary_Column__c + '_Value__c)'+config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c+',' ;
                        configID.add(config.Source_Territory_CIM__c);
                        configForAggr.add(config);
                    }
                }

                summaryCardSoqlAgr = summaryCardSoqlAgr.removeEnd(',');
                summaryCardSoqlAgr += ' FROM CIM_Position_Metric_Summary__c WHERE ';
                summaryCardSoqlCnt += ' FROM Position__c WHERE ';
                
                if(positionLevel == '2')
                {
                    summaryCardSoqlCnt += 'Parent_Position__c = : posId ';
                    summaryCardSoqlAgr += 'Position_Team_Instance__r.Parent_Position_ID__c = : posId ';
                }
                else if(positionLevel == '3')
                {
                    summaryCardSoqlCnt += 'Parent_Position__r.Parent_Position__c = : posId ';
                    summaryCardSoqlAgr += 'Position_Team_Instance__r.Parent_Position_ID__r.Parent_Position__c = : posId ';
                }
                else if(positionLevel == '4')
                {
                    summaryCardSoqlCnt += 'Parent_Position__r.Parent_Position__r.Parent_Position__c = : posId ';
                    summaryCardSoqlAgr += 'Position_Team_Instance__r.Parent_Position_ID__r.Parent_Position__r.Parent_Position__c = : posId ';
                }
                else if(integer.valueOf(positionLevel) >= 5)
                {
                    summaryCardSoqlCnt += 'Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__c = : posId ';
                    summaryCardSoqlAgr += 'Position_Team_Instance__r.Parent_Position_ID__r.Parent_Position__r.Parent_Position__r.Parent_Position__c = : posId ';
                }


                if(excludeUnassigned)
                {
                    summaryCardSoqlAgr += ' AND Position_Team_Instance__r.Position_ID__r.Is_Unassigned_Position__c = '+false+'';
                } 
                summaryCardSoqlAgr += ' AND CIM_Config__c IN : configID AND Position_Team_Instance__r.Position_ID__r.Inactive__c = '+false+' GROUP BY CIM_Config__c';

                string basePosition = SalesIQGlobalConstants.TEAM_TYPE_BASE;    
                summaryCardSoqlCnt += ' AND Team_Instance__c =: teamInstanceId and Related_Position_Type__c =: basePosition AND inactive__c = '+false+'';

                if(excludeUnassigned)
                {
                    summaryCardSoqlCnt += ' AND Is_Unassigned_Position__c = '+false+'';
                } 


                
                list<SummaryWrapper> summaryCardData = new list<SummaryWrapper>();

                /*Fill wrapper for the aggregation type count*/
                if(configForCount.size() > 0)
                {
                    system.debug('#### summaryCardSoqlCnt ' + summaryCardSoqlCnt);
                    list<AggregateResult> countResult = database.query(summaryCardSoqlCnt);
                    system.debug('#### countResult : '+countResult);
                    for(CIM_Config__c config : configForCount)
                    {

                        //CIM_Config__c configObj = cimConfigMap.get(cimMetricData.CIM_Config__c);


                        String thrMin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MIN;
                        String thrMax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MAX;
                        String thrWmin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MIN;
                        String thrWmax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MAX;
                       if(config.Metric_National_Average_Threshold_Min__c != null)
                       {
                        thrMin = String.valueOf(config.Metric_National_Average_Threshold_Min__c);
                        thrMax = String.valueOf(config.Metric_National_Average_Threshold_Max__c);
                        thrWmin = String.valueOf(config.Metric_National_Average_Warning_Min__c);
                        thrWmax = String.valueOf(config.Metric_National_Average_Warning_Max__c);
                       }
                        
                        for(AggregateResult ar : countResult)
                        {
                            system.debug('####'+config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
                            system.debug('####'+ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c));
                            integer aggrValue = (integer)ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);

                            // Decimal impact_avg_dev = AlignmentUtility.calculateNetLoss(Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c))),aggrValue,config) * 100/Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c)));
                            Decimal impact_avg_dev = 0;
                            if(Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c))) == 0)
                            {
                                impact_avg_dev = 100;
                            }  
                            else
                            {
                                impact_avg_dev = (((aggrValue - Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c))))  * 100)/Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c)))).setScale(1);
                            }




                            summaryCardData.add(new SummaryWrapper(AlignmentUtility.getLabelString(config.Display_Name__c),aggrValue,impact_avg_dev,thrMin,thrMax,thrWmin,thrWmax));
                        }
                    }
                }

                /*Fill wrapper for the aggregation type other than count*/
                if(configForAggr.size() > 0)
                {
                    system.debug('##### summaryCardSoqlAgr ' + summaryCardSoqlAgr);
                    list<AggregateResult> aggrResults = database.query(summaryCardSoqlAgr);
                    system.debug('#### aggrResults : '+aggrResults);
                    
                  
                        
                        for(CIM_Config__c config : configForAggr)
                        {

                             String thrMin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MIN;
                            String thrMax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MAX;
                            String thrWmin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MIN;
                            String thrWmax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MAX;
                           if(config.Metric_National_Average_Threshold_Min__c != null )
                           {
                            thrMin = String.valueOf(config.Metric_National_Average_Threshold_Min__c);
                            thrMax = String.valueOf(config.Metric_National_Average_Threshold_Max__c);
                            thrWmin = String.valueOf(config.Metric_National_Average_Warning_Min__c);
                            thrWmax = String.valueOf(config.Metric_National_Average_Warning_Max__c);
                           }
                                if(aggrResults!= null && aggrResults.size() > 0)
                                {
                                
                                    for(AggregateResult ar : aggrResults)
                                    {
                                        system.debug('#### '+ar.get('cimConfig'));
                                        system.debug('#### '+config.Source_Territory_CIM__c);
                                        if(ar.get('cimConfig') == config.Source_Territory_CIM__c)
                                        {
                                            system.debug('####'+config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
                                            system.debug('####'+ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c));
                                            Decimal aggrValue = (Decimal)ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
            
                                            // Decimal impact_avg_dev = AlignmentUtility.calculateNetLoss(Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c))),aggrValue,config) * 100/Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c)));
                                            Decimal impact_avg_dev = 0;
                                            if(Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c))) == 0)
                                            {
                                                impact_avg_dev = 100;
                                            }  
                                            else
                                            {
                                                impact_avg_dev = (((aggrValue - Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c)))) * 100)/Decimal.valueOf(nationalAverage.get(AlignmentUtility.getLabelString(config.Display_Name__c)))).setScale(1);
                                            }
            
            
                                            summaryCardData.add(new SummaryWrapper(AlignmentUtility.getLabelString(config.Display_Name__c),integer.valueOf(aggrValue),impact_avg_dev,thrMin,thrMax,thrWmin,thrWmax));
                                        }
                                    }
                                }else{
                                    
                                     summaryCardData.add(new SummaryWrapper(AlignmentUtility.getLabelString(config.Display_Name__c),0,0,thrMin,thrMax,thrWmin,thrWmax));
                                }
                        
                        }
                  
                }

                posSummWrap.kpiData = summaryCardData;

                territorySummaryData.add(posSummWrap);
            }
        }

        return territorySummaryData;
    }


    /*
    * Method to fetch the Heirarchy level <= Position level
    * Param 1: Selected position heirarchy level
    * Param 2: Selected team instance
    * Return : map of hierarchy level and its display name for the picklist
    */
    @RemoteAction
    public static Map<String,Map<String,String>> getHierarchyLevels(string level, string teamInstanceId)
    {
        Map<String,Map<String,String>> result = new Map<String,Map<String,String>>();        
        Map<String,String> hierarchyMap= new Map<string,string>();
        for(integer i = 1; i<=integer.valueof(level); i++)
        {
            hierarchyMap.put(String.valueof(i), AlignmentUtility.getLabelString(SalesIQUtility.getPositionTypeByHierarchy(string.valueOf(i), teamInstanceId)));
        }

        result.put('hierarchy',hierarchyMap);

        String defaultMin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MIN;
        String defaultMax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_THRESHOLD_MAX;
        String defaultWarningMin = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MIN;
        String defaultWarningMax = SalesIQGlobalConstants.NATIONAL_AVERAGE_WARNING_MAX;

        //ADD CIM NATIONAL AVG
        List<CIM_Config__c> cimNationalAverage = new List<CIM_Config__c>();
        cimNationalAverage = [select id, Name,Threshold_Min__c,Threshold_Max__c, Threshold_Warning_Min__c, Threshold_Warning_Max__c,Display_Name__c, Metric_National_Average_Threshold_Max__c, Metric_National_Average_Threshold_Min__c, Metric_National_Average_Warning_Max__c,Metric_National_Average_Warning_Min__c,Hierarchy_Level__c  FROM CIM_Config__c WHERE Team_Instance__c = :teamInstanceId AND Enable__c = true LIMIT 1000];

        
        Map<String,String> cimValuesMap= new Map<string,string>();
        Map<String,String> changeImpactValuesMap = new Map<string,string>();


        for(CIM_Config__c cim:cimNationalAverage)
        {            
                 if(cim.Metric_National_Average_Threshold_Max__c != null)
                 {
                     defaultMin = String.valueOf(cim.Metric_National_Average_Threshold_Min__c);
                     defaultMax = String.valueOf(cim.Metric_National_Average_Threshold_Max__c);
                     defaultWarningMin = String.valueOf(cim.Metric_National_Average_Warning_Min__c);
                     defaultWarningMax = String.valueOf(cim.Metric_National_Average_Warning_Max__c);
                 }

                String label_cim = AlignmentUtility.getLabelString(cim.Display_Name__c);
                String label_offset_cim = label_cim+String.valueOf(cim.Hierarchy_Level__c);
                String offset_key = label_cim+'('+Label.Original_Metric_Value+')'+String.valueOf(cim.Hierarchy_Level__c);
                String offset_key_current = label_cim+'('+Label.Current+')'+String.valueOf(cim.Hierarchy_Level__c);


                if(cim.Hierarchy_Level__c == '1')
                {


                    cimValuesMap.put('national_min'+offset_key,defaultMin);
                    cimValuesMap.put('national_max'+offset_key,defaultMax);
                    cimValuesMap.put('national_warning_min'+offset_key,defaultWarningMin);
                    cimValuesMap.put('national_warning_max'+offset_key,defaultWarningMax);
                    
                    cimValuesMap.put('national_min'+offset_key_current,defaultMin);
                    cimValuesMap.put('national_max'+offset_key_current,defaultMax);
                    cimValuesMap.put('national_warning_min'+offset_key_current,defaultWarningMin);
                    cimValuesMap.put('national_warning_max'+offset_key_current,defaultWarningMax);


                    changeImpactValuesMap.put('min'+offset_key, cim.Threshold_Min__c);
                    changeImpactValuesMap.put('max'+offset_key, cim.Threshold_Max__c);
                    changeImpactValuesMap.put('warning_min'+offset_key, cim.Threshold_Warning_Min__c);
                    changeImpactValuesMap.put('warning_max'+offset_key, cim.Threshold_Warning_Max__c);   

                    changeImpactValuesMap.put('min'+offset_key_current, cim.Threshold_Min__c);
                    changeImpactValuesMap.put('max'+offset_key_current, cim.Threshold_Max__c);
                    changeImpactValuesMap.put('warning_min'+offset_key_current, cim.Threshold_Warning_Min__c);
                    changeImpactValuesMap.put('warning_max'+offset_key_current, cim.Threshold_Warning_Max__c);   

                }else
                {
                    cimValuesMap.put('national_min'+label_offset_cim,defaultMin);
                    cimValuesMap.put('national_max'+label_offset_cim,defaultMax);
                    cimValuesMap.put('national_warning_min'+label_offset_cim,defaultWarningMin);
                    cimValuesMap.put('national_warning_max'+label_offset_cim,defaultWarningMax);


                    changeImpactValuesMap.put('min'+label_offset_cim, cim.Threshold_Min__c);
                    changeImpactValuesMap.put('max'+label_offset_cim, cim.Threshold_Max__c);
                    changeImpactValuesMap.put('warning_min'+label_offset_cim, cim.Threshold_Warning_Min__c);
                    changeImpactValuesMap.put('warning_max'+label_offset_cim, cim.Threshold_Warning_Max__c);   
                }


                
            
        }
        result.put('cim_national',cimValuesMap);
        result.put('change_impact',changeImpactValuesMap);

        return result;
    }

    
    /*
    * Method to fetch National average for all enabled KPIs (different conditions for level 1 and level > 1(summary card))
    * Param 1: Selected team instance sf id
    * Param 2: Selected Movement type
    * Param 3: Selected level from Picklist
    * Return : map of KPI display name as key and national average as value
    */
    @RemoteAction
    public static Map<String,List<PositionSummaryWrapper>> getNationalAverageData(string teamInstanceId, string movementType, string level, string positionId, Boolean excludeUnassigned)
    {
        Map<Id,CIM_Config__c> cimConfigMap = new map<Id,CIM_Config__c>(AlignmentUtility.getCIMConfigFieldsForTerritorySummary(movementType,teamInstanceId,level));

        List<PositionSummaryWrapper> positionWrapperList = new List<PositionSummaryWrapper>();   
        PositionSummaryWrapper positionWrapperObj = new PositionSummaryWrapper();
        positionWrapperObj.nationalAverageMap = new Map<String,String>();

        set<Id> cimIds = cimConfigMap.keyset();

        if(level == '1')
        {
            String soql = 'SELECT CIM_Config__c cimConfig, Avg(Proposed_Value__c) avgProposed, Avg(Approved_Value__c) avgApproved, Avg(Original_Value__c) avgOriginal FROM CIM_Position_Metric_Summary__c WHERE CIM_Config__c IN : cimIds AND Position_Team_Instance__r.Position_ID__r.Inactive__c = '+false+'';
            if(excludeUnassigned)
            {
                soql += ' AND Position_Team_Instance__r.Position_ID__r.Is_Unassigned_Position__c = '+false+'';
            } 
            soql += ' AND Position_Team_Instance__r.Position_ID__r.Team_Instance__c =: teamInstanceId GROUP BY CIM_Config__c';
           

            list<AggregateResult> nationalAverage = database.query(soql);
            
            for(AggregateResult ar : nationalAverage)
            {
                system.debug(cimConfigMap.get((Id)ar.get('cimConfig')).Display_Name__c);
                string displayName = cimConfigMap.get((Id)ar.get('cimConfig')).Display_Name__c;

                positionWrapperObj.nationalAverageMap.put(AlignmentUtility.getLabelString(displayName)+'('+Label.Original_Metric_Value+')',string.valueOf(((Decimal)ar.get('avgOriginal')).setScale(1)));
                positionWrapperObj.nationalAverageMap.put(AlignmentUtility.getLabelString(displayName)+'('+Label.Current+')',string.valueOf(((Decimal)ar.get('avgProposed')).setScale(2)));
            }
        }
        else
        {   

            string summaryCardSoqlCnt = 'SELECT ';
            string summaryCardSoqlAgr = 'SELECT CIM_Config__c cimConfig,';
            set<string> configID = new set<string>();
            set<CIM_Config__c> configForCount = new set<CIM_Config__c>();
            set<CIM_Config__c> configForAggr = new set<CIM_Config__c>();

            for(Id config : cimIds)
            {
                system.debug('####'+cimConfigMap.get(config).Id);
                if(cimConfigMap.get(config).Aggregation_Type__c == 'Count')
                {
                    summaryCardSoqlCnt +=  cimConfigMap.get(config).Aggregation_Type__c + '(Id)'+cimConfigMap.get(config).Aggregation_Type__c+'__'+cimConfigMap.get(config).Metric_Name__c+'__'+cimConfigMap.get(config).Roll_Up_Summary_Column__c+' ';
                    configForCount.add(cimConfigMap.get(config));
                }
                else
                {
                    summaryCardSoqlAgr += cimConfigMap.get(config).Aggregation_Type__c + '(' +cimConfigMap.get(config).Roll_Up_Summary_Column__c + '_Value__c)'+cimConfigMap.get(config).Aggregation_Type__c+'__'+cimConfigMap.get(config).Metric_Name__c+'__'+cimConfigMap.get(config).Roll_Up_Summary_Column__c+',' ;
                    configID.add(cimConfigMap.get(config).Source_Territory_CIM__c);
                    configForAggr.add(cimConfigMap.get(config));
                }
            }

            summaryCardSoqlAgr = summaryCardSoqlAgr.removeEnd(',');
            summaryCardSoqlAgr += ' FROM CIM_Position_Metric_Summary__c WHERE ';
            
            summaryCardSoqlCnt += ' FROM Position__c WHERE ';
            
            summaryCardSoqlAgr += 'Position_Team_Instance__r.Position_ID__r.Team_Instance__c =: teamInstanceId AND CIM_Config__c IN : configID';

            if(excludeUnassigned)
            {
                summaryCardSoqlAgr += ' AND Position_Team_Instance__r.Position_ID__r.Is_Unassigned_Position__c = '+false+'';
            }
            summaryCardSoqlAgr += ' AND Position_Team_Instance__r.Position_ID__r.Inactive__c = '+false+' GROUP BY CIM_Config__c';
           

            string basePosition = SalesIQGlobalConstants.TEAM_TYPE_BASE;    
            summaryCardSoqlCnt += 'Team_Instance__c =: teamInstanceId and Related_Position_Type__c =: basePosition AND inactive__c = '+false+'';

            if(excludeUnassigned){
                summaryCardSoqlCnt += ' AND Is_Unassigned_Position__c = '+false+'';
            }


            String countquery = 'Select id from Position__c where Hierarchy_Level__c =: level and Team_Instance__c =: teamInstanceId and Related_Position_Type__c =: basePosition AND inactive__c = '+false+'';


            if(excludeUnassigned)
            {
                countquery += ' AND Is_Unassigned_Position__c = '+false+'';
            }


            integer positionCount = database.query(countquery).size();


            if(configForCount.size() > 0)
            {
                system.debug('#### summaryCardSoqlCnt ' + summaryCardSoqlCnt);
                list<AggregateResult> countResult = database.query(summaryCardSoqlCnt);
                system.debug('#### countResult : '+countResult);
                for(CIM_Config__c config : configForCount)
                {
                    for(AggregateResult ar : countResult)
                    {
                        Decimal aggrValue = (Decimal)ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
                        positionWrapperObj.nationalAverageMap.put(AlignmentUtility.getLabelString(config.Display_Name__c),string.valueOf((aggrValue/positionCount).setScale(2)));     
                    }
                }
            }

            /*Fill wrapper for the aggregation type other than count*/
            if(configForAggr.size() > 0)
            {
                system.debug('##### summaryCardSoqlAgr ' + summaryCardSoqlAgr);
                list<AggregateResult> aggrResults = database.query(summaryCardSoqlAgr);
                system.debug('#### aggrResults : '+aggrResults);
                for(CIM_Config__c config : configForAggr)
                {
                    for(AggregateResult ar : aggrResults)
                    {
                        if(ar.get('cimConfig') == config.Source_Territory_CIM__c){
                            system.debug('####'+config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
                            system.debug('####'+ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c));
                            Decimal aggrValue = (Decimal)ar.get(config.Aggregation_Type__c+'__'+config.Metric_Name__c+'__'+config.Roll_Up_Summary_Column__c);
                            positionWrapperObj.nationalAverageMap.put(AlignmentUtility.getLabelString(config.Display_Name__c),string.valueOf((aggrValue/positionCount).setScale(2)));
                        }
                    }
                }
            }
        }
        
        Map<String,List<PositionSummaryWrapper>> result = new Map<String,List<PositionSummaryWrapper>>();
        positionWrapperList.add(positionWrapperObj);

        result.put('national_average',positionWrapperList);
        result.put('summary_data', getTerritorySummaryData(teamInstanceId, positionId, level, movementType, positionWrapperObj.nationalAverageMap, excludeUnassigned));

        return result;
    }



    public class PositionSummaryWrapper
    {
        public Id positionId;
        public String positionName;
        public String positionCode;
        public String positionType;
        public list<SummaryWrapper> kpiData;
        public Map<String,String> nationalAverageMap;

        public PositionSummaryWrapper(Id positionId, String positionName, String positionCode)
        {
            this.positionId = positionId;
            this.positionName = positionName;
            this.positionCode = positionCode;
        }

        public PositionSummaryWrapper(Id positionId, String positionName, String positionCode,String positionType)
        {       
            this.positionName = positionName;
            this.positionCode = positionCode;
            this.positionType = positionType;
        }

        public PositionSummaryWrapper()
        {
            this.nationalAverageMap = new Map<String,String>();
        }
    }


    public class SummaryWrapper{
        public string attributeDisplayName;
        public integer attributeValue;
        public Decimal avg_dev,changeImpact,error_max,error_min,warning_max,warning_min,national_max,national_min, national_warning_max,national_warning_min; //avg_dev is the deviation from the national average, changeImpact is deviation from the original value for level 1 postions, 0 otherwise
        public String textColor, graudrailHeader, graudrailToolTipMessage, errorType,graudrailRange,metricName,metrictCalculationType;
        public Boolean defaultOnConfig,isEnforcable;
        public String thrMin, thrmax, thrwMin, thrWmax;
        
        public SummaryWrapper(){
            this.attributeDisplayName = '';
            this.attributeValue = 0;
            this.avg_dev = 0;
            this.textColor = '';
            this.graudrailHeader = '';
            this.graudrailToolTipMessage = '';
            this.graudrailRange='';
            this.errorType = '';
            this.metricName='';
            this.defaultOnConfig=false;

        }
        // public SummaryWrapper(string attributeDisplayName, integer attributeValue){
        //     this.attributeDisplayName = attributeDisplayName;
        //     this.attributeValue = attributeValue;
        //     this.textColor = '';
        //     this.graudrailHeader = '';
        //     this.graudrailToolTipMessage = '';
        //     this.graudrailRange = '';
        //     this.errorType = '';
        //     this.metricName='';
        //     this.avg_dev = 0;
        //     this.changeImpact = 0;
        // }

        public SummaryWrapper(string attributeDisplayName, integer attributeValue, Decimal avg_dev,String thrMin, String thrmax, String thrwMin, String thrWmax){
            this.attributeDisplayName = attributeDisplayName;
            this.attributeValue = attributeValue;
            this.textColor = '';
            this.graudrailHeader = '';
            this.graudrailToolTipMessage = '';
            this.graudrailRange = '';
            this.errorType = '';
            this.metricName='';
            this.avg_dev = avg_dev;
            this.changeImpact = 0;
            this.thrMin = thrMin;
            this.thrmax = thrmax;
            this.thrwMin = thrwMin;
            this.thrWmax = thrWmax;
            this.isEnforcable = false;
        }

        public SummaryWrapper(string attributeDisplayName, integer attributeValue, Decimal avg_dev, Decimal changeImpact){
            this.attributeDisplayName = attributeDisplayName;
            this.attributeValue = attributeValue;
            this.textColor = '';
            this.graudrailHeader = '';
            this.graudrailToolTipMessage = '';
            this.graudrailRange = '';
            this.errorType = '';
            this.metricName='';
            this.avg_dev = avg_dev;
            this.changeImpact = changeImpact;

        }

        public SummaryWrapper(String attributeDisplayName, integer attributeValue, String textColor, String graudrailHeader, String graudrailToolTipMessage, String errorType, Decimal avg_dev,Decimal changeImpact, String thrMin, String thrmax, String thrwMin, String thrWmax)
        {
            this.attributeDisplayName = attributeDisplayName;
            this.attributeValue = attributeValue;
            this.textColor = textColor;
            this.graudrailHeader = graudrailHeader;
            this.graudrailToolTipMessage = graudrailToolTipMessage;
            this.errorType = errorType;
            this.avg_dev = avg_dev;
            this.changeImpact = changeImpact;
            this.thrMin = thrMin;
            this.thrmax = thrmax;
            this.thrwMin = thrwMin;
            this.thrWmax = thrWmax;
        }
    }
}
